/*
 * This software is the confidential and proprietary information of
 * Smardec. You shall not disclose or distribute such Confidential Information.
 * This software shall not be integrated, copied (partially or fully),
 * or reverse engineered into any other software, program, or code that is
 * not intended for Smardec. You shall use it only in accordance with the terms
 * of the license agreement you entered into with Smardec.
 *
 * Copyright (C) 2004-2006 Smardec. All rights reserved.
 *
 * http://www.smardec.com
 *
 */

package com.smardec.demo.j2native.tools;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class Cache {
    private HashMap cacheMap;

    public Cache() {
        cacheMap = new HashMap();
    }

    public void clear() {
        cacheMap.clear();
    }

    public void put(Integer id, Cachable anObject) {
        cacheMap.put(id, anObject);
        cacheMap.put(anObject.getIdent(), anObject);
    }

    public void put(String ident, Cachable anObject) {
        cacheMap.put(ident, anObject);
        cacheMap.put(new Integer(anObject.getId()), anObject);

    }

    public Cachable get(Integer id) {
        return (Cachable) cacheMap.get(id);
    }

    public Cachable get(String ident) {
        return (Cachable) cacheMap.get(ident);
    }

    public boolean remove(Cachable cachable) {
        return ((cacheMap.remove(new Integer(cachable.getId())) != null) &&
                (cacheMap.remove(cachable.getIdent()) != null));
    }

    public Cachable remove(Integer id) {
        Cachable cachable = (Cachable) cacheMap.remove(id);
        if (cachable != null) {
            return (Cachable) cacheMap.remove(cachable.getIdent());
        }
        return null;
    }

    public Cachable remove(String ident) {
        Cachable cachable = (Cachable) cacheMap.remove(ident);
        if (cachable != null) {
            return (Cachable) cacheMap.remove(new Integer(cachable.getId()));
        }
        return null;
    }

    public Iterator iterator() {
        Set set = new HashSet();
        Object[] keys = cacheMap.keySet().toArray();
        for (int i = 0; i < keys.length; i++) {
            set.add(cacheMap.get(keys[i]));
        }
        return set.iterator();
    }

}
